\begin{tikzpicture}[tools/.style = {
                      text width=50mm, minimum height=10mm,
                      text centered, draw=guixblue2, thick,
                      rounded corners=2mm,
                      fill=white, text=black
                    },
                    tool/.style = {
                      fill=white, text=black, text width=3cm,
                      text centered
                    },
                    daemon/.style = {
                      rectangle, text width=50mm, text centered,
                      rounded corners=2mm, minimum height=10mm,
                      fill=guixorange1, text=black
                    },
                    builders/.style = {
                      draw=guixorange1, very thick,
                      fill=white, text=black, text width=5cm,
                      rounded corners=2mm,
                    },
                    builder/.style = {
                      draw=guixred2, thick, rectangle,
                      fill=white, text=black,
                      rotate=90
                    }]
  \matrix[row sep=3mm, column sep=3.4cm] {
    \node(builders)[builders, text height=3.5cm]{}
        node[fill=white, text=black] at (0, 1.3) {\textbf{build processes}}
        node[fill=white, text=black] at (0, 0.9) {chroot, separate UIDs}
        node[builder] at (-1,-0.5) {\texttt{make}, \texttt{gcc}, etc.}
        node[builder] at ( 0,-0.5) {\texttt{make}, \texttt{gcc}, etc.}
        node[builder] at ( 1,-0.5) {\texttt{make}, \texttt{gcc}, etc.}; &
    \node(cli)[tools]{\texttt{guix} command};
    \\

    \node(daemon)[daemon]{\textbf{build daemon}}; &
    &
    \\
  };

  \path[very thick, draw=guixorange1]
    (cli.south) edge [out=-90, in=0, ->] node[below, sloped]{RPCs} (daemon.east);
  \path[->, very thick, draw=guixorange1]
    (daemon) edge (builders);
\end{tikzpicture}
